"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var diagnostics_channel_1 = __importDefault(require("diagnostics_channel"));
var http_1 = __importDefault(require("http"));
var https_1 = __importDefault(require("https"));
var semver_1 = __importDefault(require("semver"));
var http_2 = require("./http");
var undici_1 = require("./undici");
var utils_1 = require("../utils");
var _a = (0, utils_1.createListener)(), clientHttpInspector = _a[0], emit = _a[1];
var httpRequestChannel = diagnostics_channel_1.default.channel('http.client.request.start');
var undiciRequestChannel = diagnostics_channel_1.default.channel('undici:request:create');
if (semver_1.default.satisfies(process.versions.node, '<=16')) {
    var inspectedClientMethod = function (func) {
        var rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            rest[_i - 1] = arguments[_i];
        }
        var request = func.apply(this, rest);
        var sequence = (0, utils_1.addSequence)();
        if (clientHttpInspector.hasListeners) {
            var callable_1 = true;
            var requestDetailBody_1 = false;
            var requestDetailResolvers_2 = [];
            var responseDetailBody_1 = false;
            var responseDetailResolvers_2 = [];
            emit({
                url: "".concat(request.protocol, "//").concat(request.getHeader('host')).concat(request.path),
                method: request.method,
                time: Date.now(),
                requestHeaders: (0, http_2.parseHeaders)(request.getHeaders()),
                getRequestDetail: function (options) {
                    if (!callable_1) {
                        return Promise.reject('event.getRequestDetail needs be called imminently');
                    }
                    if (requestDetailBody_1 === false && (options === null || options === void 0 ? void 0 : options.body) === true) {
                        requestDetailBody_1 = true;
                    }
                    return new Promise(function (resolve) { return requestDetailResolvers_2.push(resolve); });
                },
                getResponseDetail: function (options) {
                    if (!callable_1) {
                        return Promise.reject('event.getResponseDetail needs be called imminently');
                    }
                    if (responseDetailBody_1 === false && (options === null || options === void 0 ? void 0 : options.body) === true) {
                        responseDetailBody_1 = true;
                    }
                    return new Promise(function (resolve) { return responseDetailResolvers_2.push(resolve); });
                },
                sequence: sequence,
            });
            callable_1 = false;
            if (requestDetailResolvers_2.length) {
                var promise = (0, http_2.getClientRequestDetail)(request, { body: requestDetailBody_1 }).catch(function (error) { return ({ error: (0, utils_1.errorToString)(error) }); });
                for (var _a = 0, requestDetailResolvers_1 = requestDetailResolvers_2; _a < requestDetailResolvers_1.length; _a++) {
                    var resolver = requestDetailResolvers_1[_a];
                    resolver(promise);
                }
                requestDetailResolvers_2.length = 0;
            }
            if (responseDetailResolvers_2.length) {
                var promise = (0, http_2.getClientResponseDetail)(request, { body: responseDetailBody_1 }).catch(function (error) { return ({ error: (0, utils_1.errorToString)(error) }); });
                for (var _b = 0, responseDetailResolvers_1 = responseDetailResolvers_2; _b < responseDetailResolvers_1.length; _b++) {
                    var resolver = responseDetailResolvers_1[_b];
                    resolver(promise);
                }
                responseDetailResolvers_2.length = 0;
            }
        }
        return request;
    };
    http_1.default.request = inspectedClientMethod.bind(http_1.default, http_1.default.request);
    http_1.default.get = inspectedClientMethod.bind(http_1.default, http_1.default.get);
    https_1.default.request = inspectedClientMethod.bind(https_1.default, https_1.default.request);
    https_1.default.get = inspectedClientMethod.bind(https_1.default, https_1.default.get);
}
else {
    httpRequestChannel.subscribe(function (event) { return __awaiter(void 0, void 0, void 0, function () {
        var request, sequence, callable_2, requestDetailBody_2, requestDetailResolvers_4, responseDetailBody_2, responseDetailResolvers_4, promise, _i, requestDetailResolvers_3, resolver, promise, _a, responseDetailResolvers_3, resolver;
        return __generator(this, function (_b) {
            request = event.request;
            sequence = (0, utils_1.addSequence)();
            if (clientHttpInspector.hasListeners) {
                callable_2 = true;
                requestDetailBody_2 = false;
                requestDetailResolvers_4 = [];
                responseDetailBody_2 = false;
                responseDetailResolvers_4 = [];
                emit({
                    url: "".concat(request.protocol, "//").concat(request.getHeader('host')).concat(request.path),
                    method: request.method,
                    time: Date.now(),
                    requestHeaders: (0, http_2.parseHeaders)(request.getHeaders()),
                    getRequestDetail: function (options) {
                        if (!callable_2) {
                            return Promise.reject('event.getRequestDetail needs be called imminently');
                        }
                        if (requestDetailBody_2 === false && (options === null || options === void 0 ? void 0 : options.body) === true) {
                            requestDetailBody_2 = true;
                        }
                        return new Promise(function (resolve) { return requestDetailResolvers_4.push(resolve); });
                    },
                    getResponseDetail: function (options) {
                        if (!callable_2) {
                            return Promise.reject('event.getResponseDetail needs be called imminently');
                        }
                        if (responseDetailBody_2 === false && (options === null || options === void 0 ? void 0 : options.body) === true) {
                            responseDetailBody_2 = true;
                        }
                        return new Promise(function (resolve) { return responseDetailResolvers_4.push(resolve); });
                    },
                    sequence: sequence,
                });
                callable_2 = false;
                if (requestDetailResolvers_4.length) {
                    promise = (0, http_2.getClientRequestDetail)(request, { body: requestDetailBody_2 }).catch(function (error) { return ({ error: (0, utils_1.errorToString)(error) }); });
                    for (_i = 0, requestDetailResolvers_3 = requestDetailResolvers_4; _i < requestDetailResolvers_3.length; _i++) {
                        resolver = requestDetailResolvers_3[_i];
                        resolver(promise);
                    }
                    requestDetailResolvers_4.length = 0;
                }
                if (responseDetailResolvers_4.length) {
                    promise = (0, http_2.getClientResponseDetail)(request, { body: responseDetailBody_2 }).catch(function (error) { return ({ error: (0, utils_1.errorToString)(error) }); });
                    for (_a = 0, responseDetailResolvers_3 = responseDetailResolvers_4; _a < responseDetailResolvers_3.length; _a++) {
                        resolver = responseDetailResolvers_3[_a];
                        resolver(promise);
                    }
                    responseDetailResolvers_4.length = 0;
                }
            }
            return [2 /*return*/];
        });
    }); });
}
undiciRequestChannel.subscribe(function (event) { return __awaiter(void 0, void 0, void 0, function () {
    var request, sequence, callable_3, requestDetailBody_3, requestDetailResolvers_6, responseDetailBody_3, responseDetailResolvers_6, promise, _i, requestDetailResolvers_5, resolver, promise, _a, responseDetailResolvers_5, resolver;
    return __generator(this, function (_b) {
        request = event.request;
        sequence = (0, utils_1.addSequence)();
        if (clientHttpInspector.hasListeners) {
            callable_3 = true;
            requestDetailBody_3 = false;
            requestDetailResolvers_6 = [];
            responseDetailBody_3 = false;
            responseDetailResolvers_6 = [];
            emit({
                url: request.origin + request.path,
                method: request.method,
                time: Date.now(),
                requestHeaders: (0, undici_1.parseUndiciRequsetHeaders)(request.headers),
                getRequestDetail: function (options) {
                    if (!callable_3) {
                        return Promise.reject('event.getRequestDetail needs be called imminently');
                    }
                    if (requestDetailBody_3 === false && (options === null || options === void 0 ? void 0 : options.body) === true) {
                        requestDetailBody_3 = true;
                    }
                    return new Promise(function (resolve) { return requestDetailResolvers_6.push(resolve); });
                },
                getResponseDetail: function (options) {
                    if (!callable_3) {
                        return Promise.reject('event.getResponseDetail needs be called imminently');
                    }
                    if (responseDetailBody_3 === false && (options === null || options === void 0 ? void 0 : options.body) === true) {
                        responseDetailBody_3 = true;
                    }
                    return new Promise(function (resolve) { return responseDetailResolvers_6.push(resolve); });
                },
                sequence: sequence,
            });
            callable_3 = false;
            if (requestDetailResolvers_6.length) {
                promise = (0, undici_1.getClientUndiciRequestDetail)(request, { body: requestDetailBody_3 }).catch(function (error) { return ({ error: (0, utils_1.errorToString)(error) }); });
                for (_i = 0, requestDetailResolvers_5 = requestDetailResolvers_6; _i < requestDetailResolvers_5.length; _i++) {
                    resolver = requestDetailResolvers_5[_i];
                    resolver(promise);
                }
                requestDetailResolvers_6.length = 0;
            }
            if (responseDetailResolvers_6.length) {
                promise = (0, undici_1.getClientUndiciResponseDetail)(request, { body: responseDetailBody_3 }).catch(function (error) { return ({ error: (0, utils_1.errorToString)(error) }); });
                for (_a = 0, responseDetailResolvers_5 = responseDetailResolvers_6; _a < responseDetailResolvers_5.length; _a++) {
                    resolver = responseDetailResolvers_5[_a];
                    resolver(promise);
                }
                responseDetailResolvers_6.length = 0;
            }
        }
        return [2 /*return*/];
    });
}); });
exports.default = clientHttpInspector;
//# sourceMappingURL=index.js.map