/// <reference types="node" />
import { ClientRequestDetail, ClientResponseDetail } from './types';
export interface UndiciRequset {
    path: string;
    headers: string;
    method: string;
    onBodySent(chunk: Buffer): void;
    onRequestSent(): void;
    onError(error: Error): void;
    onHeaders(statusCode: number, headers: Buffer[] | string[] | null, resume: () => void): boolean;
    onData(chunk: Buffer): boolean;
    onComplete(trailers: string[] | null): void;
}
export declare function getClientUndiciRequestDetail(request: UndiciRequset, options?: {
    body?: boolean;
}): Promise<ClientRequestDetail>;
export declare function getClientUndiciResponseDetail(request: UndiciRequset, options?: {
    body?: boolean;
}): Promise<ClientResponseDetail>;
export declare function parseUndiciRequsetHeaders(headerString: string): [name: string, value: string][];
export declare function parseUndiciResponseHeaders(headersList: string[] | Buffer[] | null): [name: string, value: string][];
//# sourceMappingURL=undici.d.ts.map