/// <reference types="node" />
export type Sequence = {
    id: string;
    count: number;
};
export type RequestInfo = {
    time: number;
    url: string;
    method: string;
    headers: Record<string, undefined | number | string | string[]>;
    type?: string;
    rawBody?: Buffer;
    textBody?: string;
};
export type ResponseInfo = {
    time: number;
    cost: number;
    status: number;
    headers: Record<string, undefined | number | string | string[]>;
    type?: string;
    rawBody?: Buffer;
    textBody?: string;
};
export type HttpInfo = {
    type: 'client';
    request: RequestInfo;
    response: ResponseInfo;
} | {
    type: 'server';
    request: RequestInfo;
    response: ResponseInfo;
};
//# sourceMappingURL=types.d.ts.map