/// <reference types="node" />
/// <reference types="node" />
import { Transform, Writable } from 'stream';
export declare function hasBody(method: string): boolean;
export declare function contentType(headers: [name: string, value: string][]): string | false;
export declare function createDecoders(headers: [name: string, value: string][]): Transform[];
export declare function pipeline(input: Writable, transforms: Transform[]): Promise<Buffer | null>;
export interface Listener<T extends any[]> {
    hasListeners: boolean;
    addListener(fn: (...args: T) => void): () => void;
    removeAllListeners(): void;
}
export interface Emit<T extends any[]> {
    (...args: T): void;
}
export declare function createListener<T extends any[]>(): [Listener<T>, Emit<T>];
export declare function uuid(): string;
type SequenceData = {
    id: string;
    index: number;
};
export declare function startSequence(callback: (store: SequenceData) => void): void;
export declare function addSequence(sequenceData?: SequenceData): null | SequenceData;
export declare function errorToString(error: unknown): string;
export {};
//# sourceMappingURL=utils.d.ts.map