export type ClientRequestDetail = {
  time: number;
  url: string;
  method: string;
  headers: [name: string, value: string][];
  contentType?: string;
  contentText?: string;
};

export type ClientResponseDetail = {
  time: number;
  cost: number;
  status: number;
  headers: [name: string, value: string][];
  contentType?: string;
  contentText?: string;
};

export type ClientHttpEvent = {
  time: number;
  url: string;
  method: string;
  sequence: {
    id: string;
    index: number;
  } | null;
  requestHeaders: [name: string, value: string][];
  getRequestDetail: (options?: { body?: boolean }) => Promise<ClientRequestDetail | { error: string }>
  getResponseDetail: (options?: { body?: boolean }) => Promise<ClientResponseDetail | { error: string }>;
};