export type ServerRequestDetail = {
  time: number;
  url: string;
  method: string;
  headers: [name: string, value: string][];
  contentType?: string;
  contentText?: string;
};

export type ServerResponseDetail = {
  time: number;
  cost: number;
  status: number;
  headers: [name: string, value: string][];
  contentType?: string;
  contentText?: string;
};

export type ServerHttpEvent = {
  time: number;
  url: string;
  method: string;
  socket: {
    remoteAddress: string;
    encrypted: boolean;
  };
  httpVersion: string,
  httpVersionMajor: number;
  httpVersionMinor: number;
  requestHeaders: [name: string, value: string][];
  sequence: {
    id: string;
    index: number;
  } | null;
  getRequestDetail: (options?: { body?: boolean }) => Promise<ServerRequestDetail | { error: string }>;
  getResponseDetail: (options?: { body?: boolean }) => Promise<ServerResponseDetail | { error: string }>;
};